import * as THREE from '/build/three.module.js';
import { ciel_soleil2,sol } from './index_image.js';
import {GLTFLoader} from '/3D/GLTFLoader.js';
var  camera, scene, stars=[];
function main_3D() {
  const canvas = document.querySelector('#canvas_tux');
  const renderer = new THREE.WebGLRenderer({canvas});

  const fov = 75;
  const aspect = 2;  // the canvas default
  const near = 0.1;
  const far = 50000;
  camera = new THREE.PerspectiveCamera(fov, aspect, near, far);
  camera.position.y = 4;
  camera.position.z = 9;
  const point = new THREE.Vector3( 0,4, 0 );
  camera.lookAt( point );
  
  //Window
  window.addEventListener( 'mousemove', onMouseMove );
 
  
  
//SCENE
   scene = new THREE.Scene();
  
	  const color = 0x000000;
	  
	  scene.background = new THREE.Color(color);  // black
  
//lUmiere 
  
    const color2 = 0xFFFFFF;
    const intensity = 1;
    const light = new THREE.DirectionalLight(color2, intensity);
    light.position.set(-1, 2, 4);
    scene.add(light);
  
  //SOL
   
   		
	var loader = new THREE.TextureLoader();

	// load a resource
	var texture_fonds=loader.load( sol);
	texture_fonds.wrapS = THREE.MirroredRepeatWrapping;
	texture_fonds.wrapT = THREE.MirroredRepeatWrapping;
	texture_fonds.repeat.set( 15,15);
	var fonds_Material = new THREE.MeshBasicMaterial({
						map : texture_fonds,
						transparent : true,
						 overdraw: true,
						 color:0x4488aa
					});
	var fonds_Geometry = new THREE.PlaneGeometry(20000, 3000,1,1);
	fonds_Geometry.rotateX( -Math.PI/2 );
	var fonds_Screen = new THREE.Mesh( fonds_Geometry, fonds_Material );
	fonds_Screen.position.set(0, 0,0);
	
	scene.add(fonds_Screen);
   
   
   
  
	
    //OBJETS
	
	const objLoader = new GLTFLoader();
	var Pingouin={Corps:null,Tete:null,Pied_G:null,Pied_D:null,Oeil_G:null,Oeil_D:null,Bouche:null,BrasG:null,BrasD:null};
	var GPSDO,TX_RX,Antenne_Para,Ecran,Sat1,Sat2,Sat3,Onde1,Onde2,Onde3;
	
	
	
   
	objLoader.load('/3D/TUX_GPSDO.glb', (tux) => {
		
		Pingouin.Corps = tux.scene.getObjectByName( "Tux_Corps");
		Pingouin.Tete = tux.scene.getObjectByName( "Tete");
		Pingouin.Pied_G = tux.scene.getObjectByName( "Pied_G");
		Pingouin.Pied_D = tux.scene.getObjectByName( "Pied_D");
		Pingouin.Oeil_G = tux.scene.getObjectByName( "OeilG");
		Pingouin.Oeil_D = tux.scene.getObjectByName( "OeilD");
		Pingouin.Bouche = tux.scene.getObjectByName( "Bouche");
		Pingouin.BrasG = tux.scene.getObjectByName( "BrasG");
		Pingouin.BrasD = tux.scene.getObjectByName( "BrasD");
		Antenne_Para= tux.scene.getObjectByName( "Antenne");
		TX_RX = tux.scene.getObjectByName( "TX_RX");
		GPSDO = tux.scene.getObjectByName( "GPSDO");
		Ecran = tux.scene.getObjectByName( "Ecran");
		Sat1 = tux.scene.getObjectByName( "Sat1");
		Sat2 = tux.scene.getObjectByName( "Sat2");
		Sat3 = tux.scene.getObjectByName( "Sat3");
		Onde1 = tux.scene.getObjectByName( "Onde1");
		Onde2 = tux.scene.getObjectByName( "Onde2");
		Onde3 = tux.scene.getObjectByName( "Onde3");
		
		Antenne_Para.rotation.y=-1;
		Antenne_Para.position.set(10,0,-3);
		
		TX_RX.rotation.y = -1;
		TX_RX.position.set(11,0.3,-1);
		
		GPSDO.position.set(5,0.3,0);
		
		Ecran.position.set(-5,2,4);
		
		Sat1.position.y =20;
		Sat2.position.y =30;
		Sat3.position.y =40;
		
		
	  scene.add(tux.scene);
	  console.log(Pingouin.Corps);
    });
	
	
	 
  
 
	addStars();
 

	 function resizeRendererToDisplaySize(renderer) {
		  const canvas = renderer.domElement;
		  const pixelRatio = window.devicePixelRatio;
		  const width  = canvas.clientWidth  * pixelRatio | 0;
		  const height = canvas.clientHeight * pixelRatio | 0;
		  const needResize = canvas.width !== width || canvas.height !== height;
		  if (needResize) {
			renderer.setSize(width, height, false);
		  }
		  return needResize;
    }
  function render(time) {
    time *= 0.001;  // convert time to seconds
	
	if (resizeRendererToDisplaySize(renderer)) {
		const canvas = renderer.domElement;
		camera.aspect = canvas.clientWidth / canvas.clientHeight;
		camera.updateProjectionMatrix();
	}
    if (Pingouin.Corps) {
			Pingouin.Corps.rotation.z =0.3*Math.sin(time);
			Pingouin.Tete.rotation.z = 0.3*Math.sin(time);
			Pingouin.Pied_G.rotation.z =- 0.3*Math.sin(time);
			Pingouin.Pied_D.rotation.z = -0.3*Math.sin(time);
			Pingouin.Oeil_G.rotation.x =- 0.005*Math.sin(time*3);
			Pingouin.Oeil_D.rotation.x = 0.005*Math.sin(time*4);
			Pingouin.Bouche.scale.y =0.012+0.01* Math.sin(time*10);
			Pingouin.BrasD.rotation.z = 0.5*Math.cos(time*3);
			Pingouin.BrasG.rotation.z = 0.5*Math.sin(time*3);		
    }
	
	if (Sat1  && Sat2 && Sat3){
		Sat1.rotation.y=0.3*time;
		Sat2.rotation.y=-0.3*time;
		Sat3.rotation.y=0.2*time;
		
		Sat1.position.x=Sat1.position.z=(10*time)%300-300;
		Sat2.position.x=-(10*time+100)%300+300;
		Sat2.position.z=-Sat2.position.x
		Sat3.position.z=(10*time+200)%300-300;
		
		var s= (10*time)%5;
		Onde1.scale.set(s,s,s)
		Onde2.scale.set(s,s,s)
		Onde3.scale.set(s,s,s)
		
		
	}
    
    renderer.render(scene, camera);

    requestAnimationFrame(render);
  }
  requestAnimationFrame(render);
 
}
function addStars(){

				// The loop will move from z position of -1000 to z position 1000, adding a random particle at each position. 
				for ( var z= -700; z < -500; z+=1 ) {
		
					// Make a sphere (exactly the same as before). 
					var geometry   = new THREE.SphereGeometry(0.5, 32, 32)
					var material = new THREE.MeshBasicMaterial( {color: 0xffffff} );
					var sphere = new THREE.Mesh(geometry, material)
		
					// This time we give the sphere random x and y positions between -500 and 500
					sphere.position.x = Math.random() * 6000 - 3000;
					sphere.position.y = Math.random() * 1000 - 50;
		
					// Then set the z position to where it is in the loop (distance of camera)
					sphere.position.z = z;
		
					// scale it up a bit
					sphere.scale.x = sphere.scale.y = 2;
		
					//add the sphere to the scene
					scene.add( sphere );
		
					//finally push it to the stars array 
					stars.push(sphere); 
				}
	}
 
function onMouseMove( ev ) {

	camera.position.x = -5*(0.3-ev.clientX / window.innerWidth);
	camera.position.y = 2+2*(0.5-ev.clientY / window.innerHeight);
	const point = new THREE.Vector3( 0,3, 0 );
    camera.lookAt( point );
}


main_3D();