// ***********************************
// *           REMOTE GPSDO         *
// *              F1ATB              *
// * GNU General Public Licence v3.0 *
// ***********************************
const Version="Remote GPSDO V1.0<br><a href='http://f1atb.fr' target='_blank'>F1ATB</a> June 2021";				

//Page
var ecran={large:true,largeur:1,hauteur:1,innerW:1,innerH:1,border:5};

const NbMesure=1000;
var dataReceived=[];
var LastIdxNano=-1;
var idx_current=0;
var PulseRef=100000000; // Number of pulses expected in 40s Clock 0 at 2.5MHz
var LastDiff=0;
var LastF1=0;
var LastF2=0;
var vOsc1=vOsc2=6;
var LastXref=0;
var LastCorrec=0;
var T_lastDiff=0
var Tmin=0;
var Tmax=0;	

var dataGPS=[];
var LastIdxGPS=-1;
var LastInGPS=0;

var latDM,latDMS;
var lngDM,lngDMS;

for (var i=0;i< NbMesure;i++){
		dataReceived[i]={ms:0,Name:"",val:0};
}
function Init_GPSDO(){
	$("#f1atb").html(Version);
	dragCursor();
	Init_Sliders();
	
	//ReadInitNano();
	ReadDataNano();
	setInterval("ReadDataNano();",10000);
	setInterval("ReadDataGPS();",1000);
	setInterval("Plot_Clock();",1000);
}

function ReadDataNano(){
	
	 
	var jurl="cgi-bin/status_gpsdo.py?cmd=Nano"+LastIdxNano;
	$.getJSON(jurl,
		{
			format: "json"
		},
		function(data) {
		   var lignes = data.split("&");
		   var s="";	
			 for (var i=0;i<lignes.length;i++){
				 if (lignes[i] !=""){
					 s+=lignes[i]+"<br>";
					 var col=lignes[i].split("|");
					 var donnee=col[2].split(":");
					 var valeur=0;
					 if (donnee.length>1){
						valeur=donnee[1].split(" ");
					 }
					 
					 if (LastIdxNano>col[0]) LastIdxNano = col[0];
					 LastIdxNano=Math.max(LastIdxNano,col[0]);
					 var Nom=donnee[0];
					 var Val=parseInt(valeur[0]);
					 dataReceived[idx_current]={UTC:col[1],ms:Date.parse(col[1]),Name:Nom,Val:Val};
					 idx_current=(idx_current+1) % NbMesure;
					 if(Nom=="PulseDiff") T_lastDiff = 0 ;
					 if(Nom=="FreqOscil_1")  $("#Osc1").val(Val);
					 if(Nom=="FreqOscil_2")  $("#Osc2").val(Val);
					 if(Nom=="XtalCorrection")  $("#XtalCor").val(Val);
					 if(Nom=="Set Level Osc1")  {$("#slider_level_Osc1" ).slider( "value",Val);$("#vOsc1").html(Val+ " ma");}
					 if(Nom=="Set Level Osc2")  {$("#slider_level_Osc2" ).slider( "value",Val);$("#vOsc2").html(Val+ " ma");}
				 }
			 }
			 if (s!="") $("#in_Nano").html(s); //Raw Data
			 TimeWidth();
			 Nano_Traces();
			 Diplay_last_results();
			
	})
	
}
function Nano_Traces(){
	 trace_results("FreqXtalRef","white","Reference Oscillator Frequency");
	 trace_results("XtalCorrection","yellow","Xtal Correction");
	 trace_results("PulseDiff","lightgreen","Pulses count error");
	 trace_results("FreqOscil_1","Orange","Frequency drift Oscillator 1");
	 trace_results("FreqOscil_2","PaleGoldenRod","Frequency drift Oscillator 2");
	 trace_warnings();
}
function TimeWidth(){
	var Old_Tmin=Tmin;
	var Old_Tmax=Tmax;
	Tmin=9999999999999999;
    Tmax=0;			
	for (var i=0;i< dataReceived.length;i++){
		if (dataReceived[i].ms>0){
			var Tmn=60000*Math.floor(dataReceived[i].ms/60000)
			Tmin=Math.min(Tmin,Tmn);
			Tmax=Math.max(Tmax,Tmn+60000);
		}
	}
	if (Old_Tmin != Tmin || Old_Tmax!=Tmax){
			Nano_Traces();
			Display_GPS();
	}
}

function trace_results(id,color,title){           
            
		
			var Ymin=10000000000;
            var Ymax=-1000000000;
					
				
			for (var i=0;i< dataReceived.length;i++){
				if (dataReceived[i].Name==id){
					Ymin=Math.min(Ymin,dataReceived[i].Val);
					Ymax=Math.max(Ymax,dataReceived[i].Val);
				}
			}			
			if(id=="FreqXtalRef") {Ymax=Math.min(Ymax,25010000);Ymin=Math.max(Ymin,24990000)}
			if(id=="PulseDiff") {Ymax=10;Ymin=-10}
			if(id=="FreqOscil_1" || id=="FreqOscil_2") {Ymax=10;Ymin=-10}
			var W=$("#"+id).innerWidth();
			var H=$("#"+id).innerHeight();
			
			
			var Wx=Tmax-Tmin;
			var Hy=Ymax-Ymin+.0001;
			var xWidth=W;
			var yWidth=H;
			var s='<svg width="'+W+'" height="'+H+'">';
			       
					   //Trace des points
						s+='<polyline points="';
						
						for (var ii=0;ii<dataReceived.length;ii++){
							var i=(ii+idx_current) % NbMesure;
							if (dataReceived[i].Name=="PulseDiff") LastDiff=dataReceived[i].Val;
							if (dataReceived[i].Name==id){
								var Y=dataReceived[i].Val;
								if(id=="FreqXtalRef") LastXref=Y;
								if(id=="XtalCorrection") LastCorrec=Y;
								if(id=="FreqOscil_1") LastF1=Y*(1+LastDiff/PulseRef);
								if(id=="FreqOscil_2") LastF2=Y*(1+LastDiff/PulseRef);
								if(id=="FreqOscil_1" || id=="FreqOscil_2") Y=Y*LastDiff/PulseRef;
								
								Y=Math.min(Y,Ymax);
								Y=Math.max(Y,Ymin);
								var x=Math.floor(xWidth*(dataReceived[i].ms-Tmin)/Wx);
								var y=Math.floor(yWidth*(Ymax-Y)/Hy);
								
								s+=' '+x+','+y;
							}
						}
						s+='" style="fill:none;stroke:'+color+';stroke-width:2" />';
						s+='<div class="title_curve">'+title+'</div>';
						$("#"+id).html(s);
						
						
}
function trace_warnings() { // In the background
	var W=$("#warnings").innerWidth();
	var H=$("#warnings").innerHeight();
	var s="";
	var Wx=Tmax-Tmin+.0001;
	for (var i=0;i<dataReceived.length;i++){
					
		if (dataReceived[i].Name.indexOf("WARNING")>=0){
			var x1=Math.floor(W*(dataReceived[i].ms-Tmin)/Wx);
			var wi=Math.max(1,Math.floor(W*1000/Wx));
			s+='<div class="warn" style="left:' + x1 + 'px; width:' + wi +'px;"></div>'
			
		}
			
	}
	$("#warnings").html(s);
}
function Diplay_last_results(){
	$("#Pcount").html("Pulses error : "+ format_P(LastDiff));
	$("#F_Os1").html(format_Hz(LastF1));
	$("#F_Os2").html(format_Hz(LastF2));
	$("#F_Ref").html(format_Hz(LastXref));
	$("#F_Os0").html(format_Hz(LastXref/10));
	$("#F_Xtal").html(format_Hz(LastXref*(1+LastCorrec/1000000000)));
	$("#Xcorrec").html(LastCorrec+" ppb");
}
					
function dragCursor() {
	
	var  pos = 0;
	var idVisu =document.getElementById("visus");
	idVisu.onmousemove = dragMouseMove;
	idVisu.onmouseleave = dragMouseOut;
	idVisu.addEventListener('touchmove', onTouchMove, false);
	idVisu.addEventListener('touchstart', onTouchStart, false);
	function dragMouseMove(e) {	 
		e = e || window.event;
		//e.preventDefault();
		// get the mouse cursor position at startup:
		pos = e.clientX-ecran.border;
		$("#curseur").css("left",pos+"px");
		Display_nano_data(pos);
		
	}
	function dragMouseOut(e){
		$("#info").css("display","none");
	}
	
	function onTouchStart(ev) {
		if (ev.touches.length == 1) {
			ev.preventDefault();
			pos3 = ev.touches[0].clientX;
			posDiv=parseFloat(idCurseur.style.left);
		}
	}
	function onTouchMove(ev) {
		if (ev.touches.length == 1) {
			ev.preventDefault();
			pos1 = pos3  - ev.touches[0].clientX;  
			pos3 = ev.touches[0].clientX;
			posDiv=posDiv-pos1;
			idCurseur.style.left=posDiv+"px";			
			var new_pos=posDiv+10;
			Display_nano_data( new_pos);
		}
	}
}
function Display_nano_data(pos){
	var w=ecran.largeur-2*ecran.border;
	var t0=Tmin+pos*(Tmax-Tmin)/w;
	var s,Fref="",Xc="",Pdiff="",F1="",F2="";
	var distance=99999999999999;
	
	
	for (var i=0;i<dataReceived.length;i++){
		var N=dataReceived[i].Name;
		if(N == "FreqXtalRef")  Fref= dataReceived[i].Val;
		if(N == "XtalCorrection")  Xc= dataReceived[i].Val;
		if(N == "PulseDiff")  Pdiff= parseInt(dataReceived[i].Val);
		if(N == "FreqOscil_1")  F1=0+ dataReceived[i].Val*(PulseRef+Pdiff)/PulseRef;
		if(N == "FreqOscil_2")  F2=0+ dataReceived[i].Val*(PulseRef+Pdiff)/PulseRef;
		var d=Math.abs(dataReceived[i].ms-t0);
		if (d<distance) {
			distance=d;
			s=dataReceived[i].UTC+ " UTC<br>";
			s+="Reference Freq. : "+format_Hz(Fref)+"<br>";
			s+="Xtal Correction : "+Xc+" <br>";
			s+="Pulses count error : "+Pdiff+" <br>";
			s+="Freq. Oscillator 1 : "+format_Hz(F1)+"<br>";
			s+="Freq. Oscillator 2 : "+format_Hz(F2);
		}
	}
	var l="auto";
	var r=w-pos+20;r=r+"px"
	if (pos<w/2){
		l=pos+20;m=l+"px";
		r="auto";
	} 
	$("#info").css("left",l);
	$("#info").css("right",r);
	$("#info").css("display","block");
	$("#info").html(s);
	
	
}

	

function ReadDataGPS(){
	
	
	var jurl="cgi-bin/status_gpsdo.py?cmd=GPS_Raw"+LastIdxGPS;
	
	$.getJSON(jurl,
	{
		format: "json"
	},
	function(data) { //tableau à 2 dimensions
		
		 var lignes = data.split("&");
		 var s="";			
		 for (var i=0;i<lignes.length;i++){
			 if (lignes[i] !=""){
				s+=lignes[i]+"<br>";
				var col=lignes[i].split("|");
				LastIdxGPS=Math.max(LastIdxGPS,col[0]);	
				var donnees=col[2].split(",");
				if (donnees[0].substring(3,6) == "RMC") {
					dataReceived[idx_current]={UTC:col[1],ms:Date.parse(col[1]),Name:"GPS",message:col[2],A:donnees[2]};
					LastInGPS = idx_current;
					idx_current=(idx_current+1) % NbMesure;
				}
			 }			 
		 }
		 $("#in_GPS").html(s); //Raw Data
		 TimeWidth();
		 Display_GPS();
		}
	)
		
	
}





function Display_GPS(){
	// ex: $GNRMC,071225.00,A,4338.88187,N,00707.83123,E,0.502,,230621,,,A*67dds
	
	if (dataReceived[LastInGPS].Name =="GPS") {
		var last_message=dataReceived[LastInGPS].message;
		var donnees=last_message.split(",");
		$("#heure").html(formatTimeDate(donnees[1],":"));
		
		
		$("#date").html(formatTimeDate(donnees[9]," "));
		var c="red";
		var locator="";
		latDM=latDMS="";
		lngDM=lngDMS="";
		if (donnees[2]=="A") {
			c="lightgreen";
			locator= Position_to_QRA(donnees[3],donnees[5],donnees[4],donnees[6])
		}
		
		$("#GPSonLed").css("backgroundColor",c);
		$("#latitude").html(latDM+"<br>"+latDMS);
		$("#longitude").html(lngDM+"<br>"+lngDMS);
		$("#QRA_Locator").html(locator);
		var sat="";
		if (donnees[0]=="$GNRMC") {sat="GPS + GLONASS";}
		else if (donnees[0]=="$GARMC") {sat="Galileo";}
		else if (donnees[0]=="$GPRMC") {sat="GPS";}
		else if (donnees[0]=="$GLRMC") {sat="GLONASS";}
		else if (donnees[0]=="$BDRMC" || donnees[0]=="$GBRMC") {sat="Beidou";}
		$("#constellation").html(sat);
	}
	var W=$("#locked").innerWidth();
	var H=$("#locked").innerHeight();
	var s="";
	var Wx=Tmax-Tmin;
	var x1=0;
	for (var ii=0;ii<dataReceived.length;ii++){
		var i=(ii+LastInGPS+1) % NbMesure;
		if (dataReceived[i].Name =="GPS") {
			x1=Math.floor(W*(dataReceived[i].ms-Tmin)/Wx);
			var c="red";	
			if (dataReceived[i].A=="A") c="lightgreen"; //GPS locked
			s+='<div class="lock" style="left:' + x1 + 'px;background-color:'+c+';width:1px;"></div>';		
		}				
	}
	s+='<div class="title_curve">GPS locked</div>';
	$("#locked").html(s);
	
}
function Position_to_QRA(lati,lngi,lath,lngh) {
	 var Lat=parseFloat(lati);
	 var latDeg=Math.floor(Lat/100);
	 var latMinD=Lat-100*latDeg;
	 var latMin=Math.floor(latMinD);
	 var latS=Math.floor((latMinD-latMin)*60);

	 latDM=latMinD.toFixed(3);
	 if (latMinD<10) latDM="0"+latDM;
	 latDM=latDeg+"°"+latDM+"'"+lath;
	 latDMS=latS+"''";
	 if (latS<10) latDMS="0"+latDMS;
	 latDMS=latMin+"'"+latDMS;
	 if (latMin<10) latDMS="0"+latDMS;
	 latDMS=latDeg+"°"+latDMS+lath;
	 
	 
	 var Lng=parseFloat(lngi);
	 lngDeg=Math.floor(Lng/100);
	 var lngMinD=Lng-100*lngDeg;
	 var lngMin=Math.floor(lngMinD);
	 var lngS=Math.floor((lngMinD-lngMin)*60);
	 
	 lngDM=lngMinD.toFixed(3);
	 if (lngMinD<10) lngDM="0"+lngDM;
	 lngDM=lngDeg+"°"+lngDM+"'"+lngh;
	 lngDMS=lngS+"''";
	 if (lngS<10) lngDMS="0"+lngDMS;
	 lngDMS=lngMin+"'"+lngDMS;
	 if (lngMin<10) lngDMS="0"+lngDMS;
	 lngDMS=lngDeg+"°"+lngDMS+lngh;


	 Lat=latDeg+latMinD/60; // Decimal degree
	 Lng=lngDeg+lngMinD/60;
	 if (lngh == "W") Lng=-Lng;
	 if (lath == "S") Lat=-Lat;
	 var main="ABCDEFGHIJKLMNOPQR";
	 var Lng20=(180+Lng)/20;
	 var Lat10=(90+Lat)/10;
	 var locator=main.substr(Math.floor(Lng20),1)+main.substr(Math.floor(Lat10),1);
	 var number="0123456789";
	 var LngM20=10*(Lng20-Math.floor(Lng20));
	 var LatM10=10*(Lat10-Math.floor(Lat10));
	 locator+=number.substr(Math.floor(LngM20),1) + number.substr(Math.floor(LatM10),1);
	 var sub="abcdefghijklmnopqrstuvwx";
	 locator+=sub.substr(Math.floor(24*(LngM20-Math.floor(LngM20))),1) + sub.substr(Math.floor(24*(LatM10-Math.floor(LatM10))),1);
	 return locator;
}
function valide_para(id){
	var val=$("#"+id).val();
	send_para(id,val)
}
function send_para(id,val){
	var jurl="cgi-bin/status_gpsdo.py?cmd="+id+"&val="+val;
	
	$.getJSON(jurl,
	{
		format: "json"
	},
	function(data) { 
		console.log(data)
	})
}
 
 
function Plot_Clock(){
	T_lastDiff=T_lastDiff + 1;
	var color="lightgreen";
	if (T_lastDiff>43) color="red"
	var T=Math.PI*(T_lastDiff%60)/30;
	var W=$("#sch_clock").innerWidth();
	var H=$("#sch_clock").innerHeight();
	var S='<canvas width="'+W+'" height="'+H+'" id="nanoclock"></canvas>';
	$("#sch_clock").html(S);
	
	var R=Math.min(W,H)/2;
	var c = document.getElementById("nanoclock");
	var ctx = c.getContext("2d");
	ctx.beginPath();
	ctx.arc(W/2, H/2, R, 1.5*Math.PI, 0.5* Math.PI);
	ctx.fillStyle = color;
	ctx.fill();
	if (T>Math.PI) {		
		ctx.arc(W/2, H/2, R, 0.5*Math.PI, 1.5* Math.PI);
		ctx.fill();
	}
	ctx.beginPath();
	ctx.arc(W/2, H/2, R,T +1.5*Math.PI,T +2.5*Math.PI);
	ctx.fillStyle = "black";
	ctx.fill();
	if (T>Math.PI) {		
		ctx.beginPath();
		ctx.arc(W/2, H/2, R, 1.5*Math.PI, 0.5* Math.PI);
		ctx.fillStyle = color;
		ctx.fill();
	}
	
}
function Init_Sliders(){
	$( function() {
		$( "#slider_level_Osc1" ).slider({
		  value:vOsc1,
		  min: 2,
		  max: 8,
		  step: 2,
		  slide: function( event, ui ) {
			 vOsc1=ui.value;
			 $("#vOsc1").html(vOsc1+ " ma");
			 send_para("vOsc1",vOsc1)
		  }
		});
	  } );
	$("#vOsc1").html(vOsc1+ " ma");  
	$( function() {
		$( "#slider_level_Osc2" ).slider({
		  value:vOsc2,
		  min: 2,
		  max: 8,
		  step: 2,
		  slide: function( event, ui ) {
			 vOsc2=ui.value;
			 $("#vOsc2").html(vOsc2+ " ma");
			 send_para("vOsc2",vOsc2)
		  }
		});
	  } );
	$("#vOsc2").html(vOsc2+ " ma");
	
}		  

//RESIZE
//**********
function window_resize(){

	ecran.largeur = window.innerWidth; // parametre qui gere le changement des css'
	ecran.hauteur = window.innerHeight;
	Fs=Math.max(10,ecran.hauteur/60);
	$("body").css("font-size",Fs);  //Main Font-Size
	
}


 
//Format Outputs
function format_Hz(f){
	f=Math.floor(f);
	var F=f.toString();
	var s="";
	q=0;
	for (var p=F.length-1;p>=0;p--){
		s=F.substr(p,1)+s;
		q++;
		if (q==3 || q==6 || q== 9) s=" "+s;
	}
	s=s+" Hz";
	return s;
}
function format_P(p){
	p=format_Hz(p);
	p=p.replace(" Hz", "");
	return p;
}

function formatTimeDate(v,s){
	 v="0000000" + parseInt(v);
	 var l=v.length;
	 var r=v.substr(l-6,2)+s+v.substr(l-4,2)+s+v.substr(l-2,2);
	 return r;
}

//REBOOT
function reboot_OPI(){
	var url_="/cgi-bin/RebootOPI.sh?";
	
	var r=true;
	if ( confirm("Confirm Orange Pi and Arduino Nano Reboot!")) $.get(url_);	
	
}
//Page FULL SCREEN
var FS_On =false;
function switch_page(){
	FS_On=!FS_On;
	var elem = document.documentElement;
	if (FS_On) {
			/* View in fullscreen */		
			  if (elem.requestFullscreen) {
				elem.requestFullscreen();
			  } else if (elem.mozRequestFullScreen) { /* Firefox */
				elem.mozRequestFullScreen();
			  } else if (elem.webkitRequestFullscreen) { /* Chrome, Safari and Opera */
				elem.webkitRequestFullscreen();
			  } else if (elem.msRequestFullscreen) { /* IE/Edge */
				elem.msRequestFullscreen();
			  }
	} else {	
/* Close fullscreen */
			  if (document.exitFullscreen) {
				document.exitFullscreen();
			  } else if (document.mozCancelFullScreen) { /* Firefox */
				document.mozCancelFullScreen();
			  } else if (document.webkitExitFullscreen) { /* Chrome, Safari and Opera */
				document.webkitExitFullscreen();
			  } else if (document.msExitFullscreen) { /* IE/Edge */
				document.msExitFullscreen();
			  }
	}
}